import { FocusableOption, FocusMonitor, FocusOrigin, FocusTrapFactory, LiveAnnouncer } from "@angular/cdk/a11y";
import { AfterViewInit, ElementRef, EventEmitter, OnDestroy, OnInit, TemplateRef } from "@angular/core";
import { Backdrop } from "./backdrop";
import { FrontLayerRef } from "./front-layer-ref";
import * as i0 from "@angular/core";
export declare class MatFrontlayer {
    templateRef: TemplateRef<any>;
    name: string;
    topPosition: string;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatFrontlayer, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatFrontlayer, "mat-frontlayer", never, { "name": "name"; "topPosition": "topPosition"; }, {}, never, ["*"]>;
}
export declare class MatBackdrop {
    static ɵfac: i0.ɵɵFactoryDeclaration<MatBackdrop, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatBackdrop, "mat-backdrop", never, {}, {}, never, ["mat-backlayer"]>;
}
export declare class MatBackdropTrigger implements AfterViewInit {
    private _backdrop;
    private _frontLayer;
    /** References the front layer instance that the trigger is associated with. */
    get frontLayer(): MatFrontlayer | null;
    set frontLayer(frontLayer: MatFrontlayer | null);
    constructor(_backdrop: Backdrop);
    ngAfterViewInit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatBackdropTrigger, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<MatBackdropTrigger, "mat-backdrop[matBackdropTriggerFor], mat-backdrop[mat-backdrop-trigger-for]", ["matBackdropTriggerFor"], { "frontLayer": "matBackdropTriggerFor"; }, {}, never>;
}
export declare class MatBacklayer implements OnInit {
    private _backdrop;
    private _element;
    private _focusMonitor;
    private _focusTrapFactory;
    private _liveAnnouncer;
    showContextMenu: boolean;
    private _document;
    /** The class that traps and manages focus within the backlayer. */
    private _focusTrap;
    /** Element that was focused before the backlayer was revealed. Save this to restore upon close. */
    /**
   * Type of interaction that led to the dialog being closed. This is used to determine
   * whether the focus style will be applied when returning focus to its original location
   * after the dialog is closed.
   */
    _closeInteractionType: FocusOrigin | null;
    constructor(_document: any, _backdrop: Backdrop, _element: ElementRef, _focusMonitor: FocusMonitor, _focusTrapFactory: FocusTrapFactory, _liveAnnouncer: LiveAnnouncer);
    private _trapFocus;
    private _restoreFocus;
    private _getFirstTabbable;
    /**
   * Focuses the first element that matches the given selector within the focus trap.
   * @param selector The CSS selector for the element to set focus to.
   */
    private _focusByCssSelector;
    ngOnInit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatBacklayer, [{ optional: true; }, null, null, null, null, null]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatBacklayer, "mat-backlayer", never, { "color": "color"; }, {}, never, ["mat-backlayer-title", "mat-backlayer-content"]>;
}
export declare class MatBacklayerTitle {
    static ɵfac: i0.ɵɵFactoryDeclaration<MatBacklayerTitle, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<MatBacklayerTitle, "mat-backlayer-title, [mat-backlayer-title], [matBacklayerTitle]", never, {}, {}, never>;
}
export declare class MatBacklayerContent {
    static ɵfac: i0.ɵɵFactoryDeclaration<MatBacklayerContent, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<MatBacklayerContent, "mat-backlayer-content, [mat-backlayer-content], [matBacklayerContent]", never, {}, {}, never>;
}
export declare abstract class _MatBacklayerButton implements AfterViewInit, OnDestroy, FocusableOption {
    private _elementRef;
    private _focusMonitor;
    constructor(_elementRef: ElementRef, _focusMonitor: FocusMonitor);
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    focus(origin?: FocusOrigin, options?: FocusOptions): void;
    _getHostElement(): any;
    static ɵfac: i0.ɵɵFactoryDeclaration<_MatBacklayerButton, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<_MatBacklayerButton, never, never, {}, {}, never>;
}
export declare class MatBacklayerToggle extends _MatBacklayerButton implements OnInit {
    private _backdrop;
    private elementRef;
    private focusMonitor;
    _arialabel: string;
    offset: string | 'full';
    autoFocus: string | boolean;
    restoreFocus?: string | boolean;
    open: EventEmitter<void>;
    close: EventEmitter<void>;
    _state: 'void' | 'opened';
    private _frontLayerRef;
    constructor(_backdrop: Backdrop, elementRef: ElementRef, focusMonitor: FocusMonitor);
    ngOnInit(): void;
    private _init;
    protected _getFrontLayer(): FrontLayerRef<any> | undefined;
    _opened(): boolean;
    _onClick(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatBacklayerToggle, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatBacklayerToggle, "button[mat-backlayer-toggle], button[matBacklayerToggle]", never, { "offset": "offset"; "autoFocus": "autoFocus"; "restoreFocus": "restoreFocus"; }, { "open": "open"; "close": "close"; }, never, ["*"]>;
}
export declare class MatBacklayerClose extends _MatBacklayerButton implements OnInit, OnDestroy {
    protected _backdrop: Backdrop;
    protected elementRef: ElementRef;
    protected focusMonitor: FocusMonitor;
    close: EventEmitter<void>;
    default: EventEmitter<void>;
    _state: 'void' | 'opened';
    private _frontLayerRef;
    private _originAriaLabel;
    private _beforeDropedSubscription;
    private _beforeLiftSubscription;
    private _afterLiftSubscription;
    constructor(_backdrop: Backdrop, elementRef: ElementRef, focusMonitor: FocusMonitor);
    ngOnInit(): void;
    protected _init(): void;
    ngOnDestroy(): void;
    _opened(): boolean;
    _onClick(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatBacklayerClose, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatBacklayerClose, "button[mat-backlayer-close], button[matBacklayerClose]", never, {}, { "close": "close"; "default": "default"; }, never, ["*"]>;
}
export declare class MatBacklayerCloseAnchor extends MatBacklayerClose implements OnInit {
    _role: string;
    _init(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatBacklayerCloseAnchor, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatBacklayerCloseAnchor, "a[mat-backlayer-close], a[matBacklayerClose]", never, {}, {}, never, ["*"]>;
}
export declare class MatBacklayerMove extends _MatBacklayerButton implements OnInit {
    private _backdrop;
    private elementRef;
    private focusMonitor;
    offset: string | 'full';
    autoFocus: string | boolean;
    restoreFocus: string | boolean;
    move: EventEmitter<void>;
    constructor(_backdrop: Backdrop, elementRef: ElementRef, focusMonitor: FocusMonitor);
    ngOnInit(): void;
    _onClick(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatBacklayerMove, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatBacklayerMove, "button[mat-backlayer-move], button[matBacklayerMove]", never, { "offset": "offset"; "autoFocus": "autoFocus"; "restoreFocus": "restoreFocus"; }, { "move": "move"; }, never, ["*"]>;
}
export declare class MatBacklayerSwitchTab {
    private _backdrop;
    private _active;
    set active(active: number);
    constructor(_backdrop: Backdrop);
    _onClick(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatBacklayerSwitchTab, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<MatBacklayerSwitchTab, "button[mat-backlayer-switch-tab], button[matBacklayerSwitchTab]", never, { "active": "mat-backlayer-switch-tab"; }, {}, never>;
}
