import { FocusMonitor } from "@angular/cdk/a11y";
import { ElementRef, EventEmitter, OnInit, QueryList } from "@angular/core";
import { Backdrop } from "./backdrop";
import { MatFrontlayer, _MatBacklayerButton } from "./backdrop-directives";
import * as i0 from "@angular/core";
/**
 * Scrollable content container of a front-layer.
 */
export declare class MatFrontlayerContent {
    showDividerOnScroll: boolean;
    _scrolling: boolean;
    _onScroll(event: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatFrontlayerContent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatFrontlayerContent, "[mat-frontlayer-content], mat-frontlayer-content, [matFrontLayerContent]", never, { "showDividerOnScroll": "showDividerOnScroll"; }, {}, never, ["*"]>;
}
/**
 * Title of a front-layer element. Stays fixed to the top of the dialog when scrolling.
 */
export declare class MatFrontlayerTitle {
    static ɵfac: i0.ɵɵFactoryDeclaration<MatFrontlayerTitle, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<MatFrontlayerTitle, "[mat-frontlayer-title], [matFrontLayerTitle]", never, {}, {}, never>;
}
export declare class MatFrontlayerActions {
    /**
    * Horizontal alignment of action buttons.
    */
    align?: 'start' | 'center' | 'end';
    static ɵfac: i0.ɵɵFactoryDeclaration<MatFrontlayerActions, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<MatFrontlayerActions, "[mat-frontlayer-actions], mat-frontlayer-actions, [matFrontlayerActions]", never, { "align": "align"; }, {}, never>;
}
export declare class MatFrontlayerDrop extends _MatBacklayerButton implements OnInit {
    private _backdrop;
    private elementRef;
    private focusMonitor;
    offset: string | 'full';
    autoFocus: string | boolean;
    restoreFocus: string | boolean;
    drop: EventEmitter<void>;
    _show: boolean;
    constructor(_backdrop: Backdrop, elementRef: ElementRef, focusMonitor: FocusMonitor);
    ngOnInit(): void;
    private _init;
    _onClick(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatFrontlayerDrop, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatFrontlayerDrop, "button[mat-frontlayer-drop], button[matFrontlayerDrop]", never, { "offset": "offset"; "autoFocus": "autoFocus"; "restoreFocus": "restoreFocus"; }, { "drop": "drop"; }, never, ["*"]>;
}
export declare class MatFrontLayerClose {
    private _backdrop;
    constructor(_backdrop: Backdrop);
    _onClick(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatFrontLayerClose, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<MatFrontLayerClose, "button[mat-frontlayer-close], button[matFrontlayerClose]", ["matFrontlayerClose"], {}, {}, never>;
}
export declare class MatFrontlayerGroup {
    _allTabs: QueryList<MatFrontlayer>;
    active: number;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatFrontlayerGroup, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatFrontlayerGroup, "mat-frontlayer-group", never, { "active": "active"; }, {}, ["_allTabs"], ["*"]>;
}
