import { Observable } from "rxjs";
import { FrontLayerRef } from "./front-layer-ref";
export declare class FrontLayerGroupRef {
    private _frontlayers;
    private _active;
    /** Subject for notifying that the active frontlayer of the group has finished droping down. */
    private readonly _afterSwitch;
    /** Subject for notifying the user that the frontlayer group has started closing. */
    private readonly _beforeClose;
    constructor(_frontlayers: FrontLayerRef<any>[], _active: number);
    selectedIndex(): number;
    switch(active: number): void;
    private _switch;
    /**
    * Gets an observable that is notified when the front-layer has finished lifting up.
    */
    afterSwitch(): Observable<FrontLayerRef<any>>;
    close(): void;
    /**
    * Gets an observable that is notified when the frontlayer group starts closing.
    */
    beforeClose(): Observable<void>;
}
